
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68
	LNK	#0

;Flash_Test.c,18 :: 		void main() {
;Flash_Test.c,21 :: 		PLLPRE_4_bit = 0;                  // PLLPRE<4:0> = 0  ->  N1 = 2    8MHz / 2 = 4MHz
	PUSH	W10
	PUSH	W11
	BCLR	PLLPRE_4_bit, BitPos(PLLPRE_4_bit+0)
;Flash_Test.c,22 :: 		PLLPRE_3_bit = 0;                  // (must be within 0.8 MHz to 8 MHz range)
	BCLR	PLLPRE_3_bit, BitPos(PLLPRE_3_bit+0)
;Flash_Test.c,23 :: 		PLLPRE_2_bit = 0;
	BCLR	PLLPRE_2_bit, BitPos(PLLPRE_2_bit+0)
;Flash_Test.c,24 :: 		PLLPRE_1_bit = 0;
	BCLR	PLLPRE_1_bit, BitPos(PLLPRE_1_bit+0)
;Flash_Test.c,25 :: 		PLLPRE_0_bit = 0;
	BCLR	PLLPRE_0_bit, BitPos(PLLPRE_0_bit+0)
;Flash_Test.c,26 :: 		PLLFBD =   38;                     // PLLDIV<8:0> = 38 ->  M = 40    4MHz * 40 = 160MHz
	MOV	#38, W0
	MOV	WREG, PLLFBD
;Flash_Test.c,28 :: 		PLLPOST_0_bit = 0;                 // PLLPOST<1:0> = 0 ->  N2 = 2    160MHz / 2 = 80MHz
	BCLR	PLLPOST_0_bit, BitPos(PLLPOST_0_bit+0)
;Flash_Test.c,29 :: 		PLLPOST_0_bit = 0;                 // (must be within 12.5 MHz to 80 MHz range)
	BCLR	PLLPOST_0_bit, BitPos(PLLPOST_0_bit+0)
;Flash_Test.c,30 :: 		AD1PCFGL = 0xFFFF;
	MOV	#65535, W0
	MOV	WREG, AD1PCFGL
;Flash_Test.c,31 :: 		AD1PCFGH = 0xFFFF;
	MOV	#65535, W0
	MOV	WREG, AD1PCFGH
;Flash_Test.c,32 :: 		AD2PCFGL = 0xFFFF;
	MOV	#65535, W0
	MOV	WREG, AD2PCFGL
;Flash_Test.c,35 :: 		test.a = 0xDADA;
	MOV	#56026, W0
	MOV	#0, W1
	MOV	W0, _test
	MOV	W1, _test+2
;Flash_Test.c,36 :: 		test.aa = 0xEAEA;
	MOV	#60138, W0
	MOV	#0, W1
	MOV	W0, _test+4
	MOV	W1, _test+6
;Flash_Test.c,37 :: 		test.aaa = 0xBABA;
	MOV	#47802, W0
	MOV	#0, W1
	MOV	W0, _test+8
	MOV	W1, _test+10
;Flash_Test.c,38 :: 		test.p = 0xCD;
	MOV	#205, W0
	MOV	W0, _test+12
;Flash_Test.c,39 :: 		test.pp = 0xCC;
	MOV	#204, W0
	MOV	W0, _test+14
;Flash_Test.c,40 :: 		test.ppp = 0xABC;                   // easy to find in debugger
	MOV	#2748, W0
	MOV	W0, _test+16
;Flash_Test.c,41 :: 		for(ii=0; ii<100; ii++)
	CLR	W0
	CLR	W1
	MOV	W0, _ii
	MOV	W1, _ii+2
L_main0:
	MOV	#100, W1
	MOV	#0, W2
	MOV	#lo_addr(_ii), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA GT	L__main7
	GOTO	L_main1
L__main7:
;Flash_Test.c,43 :: 		test.ary[ii]=0xAA;
	MOV	#lo_addr(_test+18), W1
	MOV	#lo_addr(_ii), W0
	ADD	W1, [W0], W1
	MOV.B	#170, W0
	MOV.B	W0, [W1]
;Flash_Test.c,41 :: 		for(ii=0; ii<100; ii++)
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_ii), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;Flash_Test.c,44 :: 		}
	GOTO	L_main0
L_main1:
;Flash_Test.c,46 :: 		EEsim_Init();                       // init EEsim
	CALL	_EEsim_Init
;Flash_Test.c,47 :: 		pv1 = &test;
	MOV	#lo_addr(_test), W0
	MOV	W0, _pv1
;Flash_Test.c,48 :: 		EEsim_Write(pv1,sizeof test);       // write STRUCT to FLASH
	MOV	#118, W11
	MOV	_pv1, W10
	CALL	_EEsim_Write
;Flash_Test.c,49 :: 		asm nop;
	NOP
;Flash_Test.c,50 :: 		asm nop;
	NOP
;Flash_Test.c,51 :: 		test.a = 0xAAAA;                    // change data in STRUCT
	MOV	#43690, W0
	MOV	#0, W1
	MOV	W0, _test
	MOV	W1, _test+2
;Flash_Test.c,52 :: 		test.aa = 0xBBBB;                   // so we can verify it was returned
	MOV	#48059, W0
	MOV	#0, W1
	MOV	W0, _test+4
	MOV	W1, _test+6
;Flash_Test.c,53 :: 		test.aaa = 0xCCCC;                  // to orig values after the READ
	MOV	#52428, W0
	MOV	#0, W1
	MOV	W0, _test+8
	MOV	W1, _test+10
;Flash_Test.c,54 :: 		for(ii=0; ii<100; ii++)
	CLR	W0
	CLR	W1
	MOV	W0, _ii
	MOV	W1, _ii+2
L_main3:
	MOV	#100, W1
	MOV	#0, W2
	MOV	#lo_addr(_ii), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA GT	L__main8
	GOTO	L_main4
L__main8:
;Flash_Test.c,56 :: 		test.ary[ii]=0xDE;
	MOV	#lo_addr(_test+18), W1
	MOV	#lo_addr(_ii), W0
	ADD	W1, [W0], W1
	MOV.B	#222, W0
	MOV.B	W0, [W1]
;Flash_Test.c,54 :: 		for(ii=0; ii<100; ii++)
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_ii), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;Flash_Test.c,57 :: 		}
	GOTO	L_main3
L_main4:
;Flash_Test.c,58 :: 		asm nop;
	NOP
;Flash_Test.c,59 :: 		pv1 = &test;
	MOV	#lo_addr(_test), W0
	MOV	W0, _pv1
;Flash_Test.c,60 :: 		EEsim_Read(pv1);                    // read data from FLASH into STRUCT
	MOV	_pv1, W10
	CALL	_EEsim_Read
;Flash_Test.c,61 :: 		asm nop;                           // debug (verify STRUCT data)
	NOP
;Flash_Test.c,62 :: 		}
L_end_main:
	POP	W11
	POP	W10
	ULNK
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main
