
_EEsim_Init:
	LNK	#0

;EEsim.c,16 :: 		void EEsim_Init(void)
;EEsim.c,18 :: 		FLASH_Erase(BASE_ADDR);  // setup 1K FLASH
	PUSH	W10
	PUSH	W11
	MOV	#43008, W10
	MOV	#2, W11
	CALL	_FLASH_Erase
;EEsim.c,19 :: 		}
L_end_EEsim_Init:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _EEsim_Init

_EEsim_Write:
	LNK	#0

;EEsim.c,28 :: 		void EEsim_Write(char* cc, int numbytes)
;EEsim.c,30 :: 		asm nop;
	PUSH	W12
	NOP
;EEsim.c,31 :: 		asm nop;
	NOP
;EEsim.c,34 :: 		ll = BASE_ADDR;
	MOV	#43008, W0
	MOV	#2, W1
	MOV	W0, _ll
	MOV	W1, _ll+2
;EEsim.c,35 :: 		for(res2=0;res2<8;res2++)                   // 8 writes
	MOV	#lo_addr(_res2), W1
	CLR	W0
	MOV.B	W0, [W1]
L_EEsim_Write0:
	MOV	#lo_addr(_res2), W0
	MOV.B	[W0], W0
	CP.B	W0, #8
	BRA LTU	L__EEsim_Write8
	GOTO	L_EEsim_Write1
L__EEsim_Write8:
;EEsim.c,37 :: 		FLASH_Write_Compact(ll,cc);             //chunk
	PUSH.D	W10
	MOV	W10, W12
	MOV	_ll, W10
	MOV	_ll+2, W11
	CALL	_FLASH_Write_Compact
	POP.D	W10
;EEsim.c,38 :: 		cc += 128; ll+=128;                     // inc ptr
	MOV	#128, W0
	ADD	W10, W0, W0
	MOV	W0, W10
	MOV	#128, W1
	MOV	#0, W2
	MOV	#lo_addr(_ll), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;EEsim.c,39 :: 		asm nop;                                // debug
	NOP
;EEsim.c,35 :: 		for(res2=0;res2<8;res2++)                   // 8 writes
	MOV.B	#1, W1
	MOV	#lo_addr(_res2), W0
	ADD.B	W1, [W0], [W0]
;EEsim.c,40 :: 		}
	GOTO	L_EEsim_Write0
L_EEsim_Write1:
;EEsim.c,41 :: 		asm nop;
	NOP
;EEsim.c,42 :: 		}
L_end_EEsim_Write:
	POP	W12
	ULNK
	RETURN
; end of _EEsim_Write

_EEsim_Read:
	LNK	#0

;EEsim.c,44 :: 		void EEsim_Read(char* cc)
;EEsim.c,46 :: 		asm nop;
	PUSH	W11
	PUSH	W12
	PUSH	W13
	NOP
;EEsim.c,47 :: 		asm nop;
	NOP
;EEsim.c,50 :: 		ll = BASE_ADDR;
	MOV	#43008, W0
	MOV	#2, W1
	MOV	W0, _ll
	MOV	W1, _ll+2
;EEsim.c,51 :: 		for(res2=0;res2<8;res2++)                   // 8 writes
	MOV	#lo_addr(_res2), W1
	CLR	W0
	MOV.B	W0, [W1]
L_EEsim_Read3:
	MOV	#lo_addr(_res2), W0
	MOV.B	[W0], W0
	CP.B	W0, #8
	BRA LTU	L__EEsim_Read10
	GOTO	L_EEsim_Read4
L__EEsim_Read10:
;EEsim.c,53 :: 		FLASH_Read_Compact(ll,cc,192);          //192 byte chunk
	PUSH	W10
	MOV	#192, W13
	MOV	W10, W12
	MOV	_ll, W10
	MOV	_ll+2, W11
	CALL	_FLASH_Read_Compact
	POP	W10
;EEsim.c,54 :: 		cc += 128; ll+=128;                     // inc ptr
	MOV	#128, W0
	ADD	W10, W0, W0
	MOV	W0, W10
	MOV	#128, W1
	MOV	#0, W2
	MOV	#lo_addr(_ll), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;EEsim.c,55 :: 		asm nop;                                // debug
	NOP
;EEsim.c,51 :: 		for(res2=0;res2<8;res2++)                   // 8 writes
	MOV.B	#1, W1
	MOV	#lo_addr(_res2), W0
	ADD.B	W1, [W0], [W0]
;EEsim.c,56 :: 		}
	GOTO	L_EEsim_Read3
L_EEsim_Read4:
;EEsim.c,57 :: 		asm nop;
	NOP
;EEsim.c,58 :: 		}
L_end_EEsim_Read:
	POP	W13
	POP	W12
	POP	W11
	ULNK
	RETURN
; end of _EEsim_Read
